ifeq ($(GNUSTEP_MAKEINFO),)
  GNUSTEP_MAKEINFO = makeinfo
endif
ifeq ($(GNUSTEP_MAKEINFO_FLAGS),)
  GNUSTEP_MAKEINFO_FLAGS = -D NO-TEXI2HTML
endif
ifeq ($(GNUSTEP_MAKETEXT),)
  GNUSTEP_MAKETEXT = makeinfo
endif
ifeq ($(GNUSTEP_MAKETEXT_FLAGS),)
  GNUSTEP_MAKETEXT_FLAGS = -D NO-TEXI2HTML -D TEXT-ONLY --no-header --no-split
endif
ifeq ($(GNUSTEP_TEXI2DVI),)
  GNUSTEP_TEXI2DVI = texi2dvi
endif
ifeq ($(GNUSTEP_TEXI2DVI_FLAGS),)
  GNUSTEP_TEXI2DVI_FLAGS =
endif
ifeq ($(GNUSTEP_TEXI2PDF),)
  GNUSTEP_TEXI2PDF = texi2pdf
endif
ifeq ($(GNUSTEP_TEXI2PDF_FLAGS),)
  GNUSTEP_TEXI2PDF_FLAGS =
endif
ifeq ($(GNUSTEP_TEXI2HTML),)
  GNUSTEP_TEXI2HTML = makeinfo --html
endif
ifeq ($(GNUSTEP_TEXI2HTML_FLAGS),)
  GNUSTEP_TEXI2HTML_FLAGS =
endif
ifeq ($(TEXT_MAIN),)
  SETFILENAME := $(shell grep ^@setfilename $(GNUSTEP_INSTANCE).texi)
    ifneq ($(SETFILENAME),)
      OUTFILE := $(subst .info,,$(word 2, $(SETFILENAME)))
    else
      OUTFILE := $(GNUSTEP_INSTANCE)
  endif
endif
internal-doc-all_:: $(OUTFILE).info \
                    $(OUTFILE).pdf \
                    $(OUTFILE)/index.html
internal-textdoc-all_:: $(GNUSTEP_INSTANCE)
$(OUTFILE).info: $(TEXI_FILES)
	-$(GNUSTEP_MAKEINFO) $(GNUSTEP_MAKEINFO_FLAGS) $(ADDITIONAL_MAKEINFO_FLAGS) \
		-o $@ $(GNUSTEP_INSTANCE).texi
$(GNUSTEP_INSTANCE).dvi: $(TEXI_FILES)
	-$(GNUSTEP_TEXI2DVI) $(GNUSTEP_TEXI2DVI_FLAGS) $(ADDITIONAL_TEXI2DVI_FLAGS) \
	        $(GNUSTEP_INSTANCE).texi
$(GNUSTEP_INSTANCE).ps: $(GNUSTEP_INSTANCE).dvi
	-$(GNUSTEP_DVIPS) $(GNUSTEP_DVIPS_FLAGS) $(ADDITIONAL_DVIPS_FLAGS) \
		$(GNUSTEP_INSTANCE).dvi -o $@
$(OUTFILE).pdf: $(TEXI_FILES)
	-$(GNUSTEP_TEXI2PDF) $(GNUSTEP_TEXI2PDF_FLAGS) $(ADDITIONAL_TEXI2PDF_FLAGS) \
		$(GNUSTEP_INSTANCE).texi -o $@
$(OUTFILE)/index.html: $(TEXI_FILES)
	-$(GNUSTEP_TEXI2HTML) \
                $(GNUSTEP_TEXI2HTML_FLAGS) $(ADDITIONAL_TEXI2HTML_FLAGS) \
		$(GNUSTEP_INSTANCE).texi; \
                if [ -f $(OUTFILE)/$(OUTFILE)_toc.html ]; \
                then \
                  mv $(OUTFILE)/$(OUTFILE).html .; \
                  mv $(OUTFILE)/$(OUTFILE)_*.html .; \
                  rmdir $(OUTFILE)/$(OUTFILE); \
                fi
$(GNUSTEP_INSTANCE): $(TEXI_FILES) $(TEXT_MAIN)
	-$(GNUSTEP_MAKETEXT) $(GNUSTEP_MAKETEXT_FLAGS) $(ADDITIONAL_MAKETEXT_FLAGS) \
		-o $@ $(TEXT_MAIN)
internal-doc-clean::
	-$(ECHO_NOTHING) rm -f $(GNUSTEP_INSTANCE).aux  \
	         $(GNUSTEP_INSTANCE).cp   \
	         $(GNUSTEP_INSTANCE).cps  \
	         $(GNUSTEP_INSTANCE).dvi  \
	         $(GNUSTEP_INSTANCE).fn*  \
	         $(OUTFILE).info* \
	         $(GNUSTEP_INSTANCE).ky   \
	         $(GNUSTEP_INSTANCE).log  \
	         $(GNUSTEP_INSTANCE).pg   \
	         $(GNUSTEP_INSTANCE).ps   \
	         $(OUTFILE).pdf  \
	         $(GNUSTEP_INSTANCE).toc  \
	         $(GNUSTEP_INSTANCE).tp   \
	         $(GNUSTEP_INSTANCE).vr   \
	         $(GNUSTEP_INSTANCE).vrs  \
		 $(GNUSTEP_INSTANCE).html \
		 $(GNUSTEP_INSTANCE)_*.html \
	         $(GNUSTEP_INSTANCE).ps.gz  \
	         $(GNUSTEP_INSTANCE).tar.gz \
	         $(OUTFILE)/*$(END_ECHO)
	-$(ECHO_NOTHING) rmdir $(OUTFILE) $(END_ECHO)
internal-doc-install_:: $(GNUSTEP_DOC_INFO)
	if [ -f $(OUTFILE).pdf ]; then \
	  $(INSTALL_DATA) $(OUTFILE).pdf \
	                $(GNUSTEP_DOC)/$(DOC_INSTALL_DIR); \
	fi
	if [ -f $(OUTFILE).info ]; then \
	  $(INSTALL_DATA) $(OUTFILE).info* $(GNUSTEP_DOC_INFO); \
	fi
	if [ -f i$(OUTFILE)_toc.html ]; then \
	  $(INSTALL_DATA) $(OUTFILE)_*.html \
	                  $(GNUSTEP_DOC)/$(DOC_INSTALL_DIR) || true ; \
	fi
	if [ -f $(OUTFILE)/index.html ]; then \
	  $(MKINSTALLDIRS) $(GNUSTEP_DOC)/$(DOC_INSTALL_DIR)/$(OUTFILE); \
	  $(INSTALL_DATA) $(OUTFILE)/*.html \
	                  $(GNUSTEP_DOC)/$(DOC_INSTALL_DIR)/$(OUTFILE); \
	fi
$(GNUSTEP_DOC_INFO):
	$(ECHO_CREATING)$(MKINSTALLDIRS) $@$(END_ECHO)
internal-doc-uninstall_::
	rm -f \
          $(GNUSTEP_DOC)/$(DOC_INSTALL_DIR)/$(OUTFILE).pdf
	rm -f \
          $(GNUSTEP_DOC_INFO)/$(OUTFILE).info*
	rm -f \
          $(GNUSTEP_DOC)/$(DOC_INSTALL_DIR)/$(OUTFILE)_*.html
	rm -f \
          $(GNUSTEP_DOC)/$(DOC_INSTALL_DIR)/$(OUTFILE).html
	rm -f \
	  $(GNUSTEP_DOC)/$(DOC_INSTALL_DIR)/$(OUTFILE)/*.html
internal-textdoc-install_:: $(GNUSTEP_DOC)/$(DOC_INSTALL_DIR)
	$(ECHO_NOTHING)if [ -f $(GNUSTEP_INSTANCE) ]; then \
	    $(INSTALL_DATA) $(GNUSTEP_INSTANCE) $(GNUSTEP_DOC)/$(DOC_INSTALL_DIR); \
	else \
	  $(ALWAYS_INSIDE_ECHO_MISSING_DOCUMENTATION) \
	fi$(END_ECHO)
internal-textdoc-uninstall_::
	$(ECHO_UNINSTALLING)rm -f \
          $(GNUSTEP_DOC)/$(DOC_INSTALL_DIR)/$(GNUSTEP_INSTANCE)$(END_ECHO)
internal-textdoc-clean::
	$(ECHO_NOTHING) rm -f $(GNUSTEP_INSTANCE) $(END_ECHO)
internal-textdoc-distclean::
