RESOURCE_FILES_DIR = $($(GNUSTEP_INSTANCE)_RESOURCE_FILES_DIR)
ifeq ($(RESOURCE_FILES_DIR),)
RESOURCE_FILES_DIR = ./
endif
RESOURCE_FILES = $(strip $($(GNUSTEP_INSTANCE)_RESOURCE_FILES) \
                        $($(GNUSTEP_INSTANCE)_COMPONENTS))
RESOURCE_DIRS = $(strip $($(GNUSTEP_INSTANCE)_RESOURCE_DIRS))
LOCALIZED_RESOURCE_FILES = \
  $(strip $($(GNUSTEP_INSTANCE)_LOCALIZED_RESOURCE_FILES) \
         $($(GNUSTEP_INSTANCE)_LOCALIZED_COMPONENTS))
LOCALIZED_RESOURCE_DIRS = \
  $(strip $($(GNUSTEP_INSTANCE)_LOCALIZED_RESOURCE_DIRS))
_SUBPROJECTS = $(strip $($(GNUSTEP_INSTANCE)_SUBPROJECTS))
.PHONY: \
shared-instance-bundle-all \
shared-instance-bundle-all-resources \
shared-instance-bundle-all-gsweb \
shared-instance-bundle-install \
shared-instance-bundle-uninstall \
shared-instance-bundle-copy_into_dir
ifneq ($(RESOURCE_DIRS),)
FULL_RESOURCE_DIRS = \
$(foreach d, $(RESOURCE_DIRS), $(GNUSTEP_SHARED_BUNDLE_RESOURCE_PATH)/$(d))
endif
$(GNUSTEP_SHARED_BUNDLE_RESOURCE_PATH):
	$(ECHO_CREATING)$(MKDIRS) $@$(END_ECHO)
$(FULL_RESOURCE_DIRS):
	$(ECHO_CREATING)$(MKDIRS) $@$(END_ECHO)
shared-instance-bundle-all: $(GNUSTEP_SHARED_BUNDLE_RESOURCE_PATH) \
                      $(FULL_RESOURCE_DIRS) \
                      shared-instance-bundle-all-gsweb
ifneq ($(RESOURCE_FILES),)
	$(ECHO_COPYING_RESOURCES)for f in $(RESOURCE_FILES); do \
	  if [ -f $(RESOURCE_FILES_DIR)/$$f -o -d $(RESOURCE_FILES_DIR)/$$f ]; then \
	    cp -fr $(RESOURCE_FILES_DIR)/$$f $(GNUSTEP_SHARED_BUNDLE_RESOURCE_PATH)/; \
	  else \
	    echo "Warning: $(RESOURCE_FILES_DIR)/$$f not found - ignoring"; \
	  fi; \
	done$(END_ECHO)
endif
ifneq ($(LOCALIZED_RESOURCE_DIRS),)
	$(ECHO_CREATING_LOC_RESOURCE_DIRS)for l in $(LANGUAGES); do \
	  if [ -d $(RESOURCE_FILES_DIR)/$$l.lproj ]; then \
	    $(MKDIRS) $(GNUSTEP_SHARED_BUNDLE_RESOURCE_PATH)/$$l.lproj; \
	    for f in $(LOCALIZED_RESOURCE_DIRS); do \
	      $(MKDIRS) $(GNUSTEP_SHARED_BUNDLE_RESOURCE_PATH)/$$l.lproj/$$f; \
	    done; \
	  else \
	    echo "Warning: $(RESOURCE_FILES_DIR)/$$l.lproj not found - ignoring"; \
	  fi; \
	done$(END_ECHO)
endif
ifneq ($(LOCALIZED_RESOURCE_FILES),)
	$(ECHO_COPYING_LOC_RESOURCES)for l in $(LANGUAGES); do \
	  if [ -d $(RESOURCE_FILES_DIR)/$$l.lproj ]; then \
	    $(MKDIRS) $(GNUSTEP_SHARED_BUNDLE_RESOURCE_PATH)/$$l.lproj; \
	    for f in $(LOCALIZED_RESOURCE_FILES); do \
	      if [ -f $(RESOURCE_FILES_DIR)/$$l.lproj/$$f -o -d $(RESOURCE_FILES_DIR)/$$l.lproj/$$f ]; then \
	        cp -fr $(RESOURCE_FILES_DIR)/$$l.lproj/$$f \
	              $(GNUSTEP_SHARED_BUNDLE_RESOURCE_PATH)/$$l.lproj/; \
	      else \
	        echo "Warning: $(RESOURCE_FILES_DIR)/$$l.lproj/$$f not found - ignoring"; \
	      fi; \
	    done; \
	  else \
	    echo "Warning: $(RESOURCE_FILES_DIR)/$$l.lproj not found - ignoring"; \
	  fi; \
	done$(END_ECHO)
endif
ifneq ($(_SUBPROJECTS),)
	$(ECHO_COPYING_RESOURCES_FROM_SUBPROJS)for subproject in $(_SUBPROJECTS); do \
	  if [ -d $$subproject/Resources/Subproject ]; then \
	    for f in $$subproject/Resources/Subproject/*; do \
	      if [ $$f != $$subproject'/Resources/Subproject/*' ]; then \
	        cp -fr $$f $(GNUSTEP_SHARED_BUNDLE_RESOURCE_PATH)/; \
	      fi; \
	    done; \
	  fi; \
	done$(END_ECHO)
endif
WEBSERVER_RESOURCE_FILES = \
  $(strip $($(GNUSTEP_INSTANCE)_WEBSERVER_RESOURCE_FILES) \
         $($(GNUSTEP_INSTANCE)_WEBSERVER_COMPONENTS))
WEBSERVER_LOCALIZED_RESOURCE_FILES = \
  $(strip $($(GNUSTEP_INSTANCE)_LOCALIZED_WEBSERVER_RESOURCE_FILES) \
         $($(GNUSTEP_INSTANCE)_WEBSERVER_LOCALIZED_RESOURCE_FILES) \
         $($(GNUSTEP_INSTANCE)_WEBSERVER_LOCALIZED_COMPONENTS))
WEBSERVER_RESOURCE_DIRS = \
  $(strip $($(GNUSTEP_INSTANCE)_WEBSERVER_RESOURCE_DIRS))
WEBSERVER_LOCALIZED_RESOURCE_DIRS = \
  $(strip $($(GNUSTEP_INSTANCE)_WEBSERVER_LOCALIZED_RESOURCE_DIRS))
ifneq ($(WEBSERVER_RESOURCE_DIRS),)
WEBSERVER_FULL_RESOURCE_DIRS = \
$(foreach d, $(WEBSERVER_RESOURCE_DIRS), $(GNUSTEP_SHARED_BUNDLE_RESOURCE_PATH)/WebServer/$(d))
$(WEBSERVER_FULL_RESOURCE_DIRS):
	$(ECHO_CREATING)$(MKDIRS) $@$(END_ECHO)
endif
.PHONY: shared-instance-bundle-all-webresources \
       shared-instance-bundle-all-localized-webresources
shared-instance-bundle-all-gsweb: shared-instance-bundle-all-webresources \
                           shared-instance-bundle-all-localized-webresources
ifneq ($(WEBSERVER_RESOURCE_FILES),)
$(GNUSTEP_SHARED_BUNDLE_RESOURCE_PATH)/WebServer:
	$(ECHO_CREATING)$(MKDIRS) $@$(END_ECHO)
shared-instance-bundle-all-webresources: \
  $(GNUSTEP_SHARED_BUNDLE_RESOURCE_PATH)/WebServer \
  $(WEBSERVER_FULL_RESOURCE_DIRS)
	$(ECHO_COPYING_WEBSERVER_RESOURCES)for f in $(WEBSERVER_RESOURCE_FILES); do \
	  if [ -f ./WebServerResources/$$f \
	       -o -d ./WebServerResources/$$f ]; then \
	    cp -fr ./WebServerResources/$$f \
	       $(GNUSTEP_SHARED_BUNDLE_RESOURCE_PATH)/WebServer/$$f; \
	  else \
	    echo "Warning: WebServerResources/$$f not found - ignoring"; \
	  fi; \
	done$(END_ECHO)
else
shared-instance-bundle-all-webresources:
endif
ifneq ($(WEBSERVER_LOCALIZED_RESOURCE_FILES)$(WEBSERVER_LOCALIZED_RESOURCE_DIRS),)
shared-instance-bundle-all-localized-webresources: \
  $(WEBSERVER_FULL_RESOURCE_DIRS)
ifneq ($(WEBSERVER_LOCALIZED_RESOURCE_DIRS),)
	$(ECHO_CREATING_WEBSERVER_LOC_RESOURCE_DIRS)for l in $(LANGUAGES); do \
	 if [ -d ./WebServerResources/$$l.lproj ]; then \
	  $(MKDIRS) \
	   $(GNUSTEP_SHARED_BUNDLE_RESOURCE_PATH)/WebServer/$$l.lproj; \
	  for f in $(WEBSERVER_LOCALIZED_RESOURCE_DIRS); do \
	   $(MKDIRS) \
	     $(GNUSTEP_SHARED_BUNDLE_RESOURCE_PATH)/WebServer/$$l.lproj/$$f; \
	    done; \
	  else \
	    echo "Warning: WebServer/$$l.lproj not found - ignoring"; \
	  fi; \
	done$(END_ECHO)
endif
ifneq ($(WEBSERVER_LOCALIZED_RESOURCE_FILES),)
	$(ECHO_COPYING_WEBSERVER_LOC_RESOURCES)for l in $(LANGUAGES); do \
	 if [ -d ./WebServerResources/$$l.lproj ]; then \
	  $(MKDIRS) \
	  $(GNUSTEP_SHARED_BUNDLE_RESOURCE_PATH)/WebServer/$$l.lproj;\
	  for f in $(WEBSERVER_LOCALIZED_RESOURCE_FILES); do \
	   if [ -f ./WebServerResources/$$l.lproj/$$f \
	        -o -d ./WebServerResources/$$l.lproj/$$f ]; then \
	    cp -fr ./WebServerResources/$$l.lproj/$$f \
	          $(GNUSTEP_SHARED_BUNDLE_RESOURCE_PATH)/WebServer/$$l.lproj/$$f; \
	      else \
	        echo "Warning: WebServerResources/$$l.lproj/$$f not found - ignoring"; \
	      fi; \
	    done; \
	  else \
	    echo "Warning: WebServerResources/$$l.lproj not found - ignoring"; \
	  fi; \
	done$(END_ECHO)
endif
else
shared-instance-bundle-all-localized-webresources:
endif
shared-instance-bundle-install:: $(GNUSTEP_SHARED_BUNDLE_INSTALL_PATH)
	$(ECHO_INSTALLING_BUNDLE)rm -rf $(GNUSTEP_SHARED_BUNDLE_INSTALL_PATH)/$(GNUSTEP_SHARED_BUNDLE_INSTALL_NAME); \
        $(MKINSTALLDIRS) $(GNUSTEP_SHARED_BUNDLE_INSTALL_PATH); \
	(cd $(GNUSTEP_BUILD_DIR)/$(GNUSTEP_SHARED_BUNDLE_INSTALL_LOCAL_PATH); \
	    $(TAR) chfX - $(GNUSTEP_MAKEFILES)/tar-exclude-list $(GNUSTEP_SHARED_BUNDLE_INSTALL_NAME)) \
	 | (cd $(GNUSTEP_SHARED_BUNDLE_INSTALL_PATH); $(TAR) xf -)$(END_ECHO)
ifneq ($(CHOWN_TO),)
	$(ECHO_CHOWNING)$(CHOWN) -R $(CHOWN_TO) \
	  $(GNUSTEP_SHARED_BUNDLE_INSTALL_PATH)/$(GNUSTEP_SHARED_BUNDLE_INSTALL_NAME)$(END_ECHO)
endif
shared-instance-bundle-copy_into_dir::
	$(ECHO_COPYING_BUNDLE_INTO_DIR)rm -rf $(COPY_INTO_DIR)/$(GNUSTEP_SHARED_BUNDLE_INSTALL_LOCAL_PATH)/$(GNUSTEP_SHARED_BUNDLE_INSTALL_NAME); \
	(cd $(GNUSTEP_BUILD_DIR); \
	    $(TAR) chfX - $(GNUSTEP_MAKEFILES)/tar-exclude-list $(GNUSTEP_SHARED_BUNDLE_INSTALL_LOCAL_PATH)/$(GNUSTEP_SHARED_BUNDLE_INSTALL_NAME)) \
	 | (cd $(COPY_INTO_DIR); $(TAR) xf -)$(END_ECHO)
shared-instance-bundle-uninstall::
	$(ECHO_NOTHING)cd $(GNUSTEP_SHARED_BUNDLE_INSTALL_PATH); rm -rf $(GNUSTEP_SHARED_BUNDLE_INSTALL_NAME)$(END_ECHO)
