ifeq ($(RULES_MAKE_LOADED),)
include $(GNUSTEP_MAKEFILES)/rules.make
endif
.PHONY: internal-subproject-all_       \
        internal-subproject-install_   \
        internal-subproject-uninstall_ \
	internal-subproject-compile
ifeq ($(GNUSTEP_MAKE_PARALLEL_BUILDING), no)
internal-subproject-all_:: $(GNUSTEP_OBJ_INSTANCE_DIR) \
                           $(OBJ_DIRS_TO_CREATE) \
                           $(GNUSTEP_OBJ_DIR)/$(SUBPROJECT_PRODUCT)
else
internal-subproject-all_:: $(GNUSTEP_OBJ_INSTANCE_DIR) $(OBJ_DIRS_TO_CREATE)
	$(ECHO_NOTHING_RECURSIVE_MAKE)$(MAKE) -f $(MAKEFILE_NAME) --no-print-directory --no-keep-going \
	internal-subproject-compile \
	GNUSTEP_TYPE=$(GNUSTEP_TYPE) \
	GNUSTEP_INSTANCE=$(GNUSTEP_INSTANCE) \
	GNUSTEP_OPERATION=compile \
	GNUSTEP_BUILD_DIR="$(GNUSTEP_BUILD_DIR)" \
	_GNUSTEP_MAKE_PARALLEL=yes$(END_ECHO_RECURSIVE_MAKE)
internal-subproject-compile: $(GNUSTEP_OBJ_DIR)/$(SUBPROJECT_PRODUCT)
endif
$(GNUSTEP_OBJ_DIR)/$(SUBPROJECT_PRODUCT): $(OBJ_FILES_TO_LINK)
ifeq ($(OBJ_FILES_TO_LINK),)
	$(WARNING_EMPTY_LINKING)
endif
	@echo "$(OBJ_FILES_TO_LINK)" > $(GNUSTEP_OBJ_DIR)/$(SUBPROJECT_PRODUCT)
ifneq ($(OWNING_PROJECT_HEADER_DIR_NAME),)
.PHONY: internal-subproject-build-headers
OWNING_PROJECT_HEADER_DIR = $(GNUSTEP_BUILD_DIR)/$(OWNING_PROJECT_HEADER_DIR_NAME)
HEADER_FILES   = $($(GNUSTEP_INSTANCE)_HEADER_FILES)
HEADER_SUBDIRS = $(strip $(filter-out ./,$(sort $(dir $(HEADER_FILES)))))
HEADER_FILES_DIR = $($(GNUSTEP_INSTANCE)_HEADER_FILES_DIR)
ifeq ($(HEADER_FILES_DIR),)
  HEADER_FILES_DIR = .
endif
OWNING_PROJECT_HEADER_FILES   = $(addprefix $(OWNING_PROJECT_HEADER_DIR)/,$(HEADER_FILES))
OWNING_PROJECT_HEADER_SUBDIRS = $(addprefix $(OWNING_PROJECT_HEADER_DIR)/,$(HEADER_SUBDIRS))
internal-subproject-build-headers:: $(OWNING_PROJECT_HEADER_DIR) \
                                    $(OWNING_PROJECT_HEADER_SUBDIRS) \
                                    $(OWNING_PROJECT_HEADER_FILES)
$(OWNING_PROJECT_HEADER_DIR):
	$(ECHO_CREATING)$(MKDIRS) $@$(END_ECHO)
$(OWNING_PROJECT_HEADER_SUBDIRS):
	$(ECHO_CREATING)$(MKDIRS) $@$(END_ECHO)
$(OWNING_PROJECT_HEADER_DIR)/%.h: $(HEADER_FILES_DIR)/%.h
	$(ECHO_CREATING)$(INSTALL_DATA) $< $@$(END_ECHO)
else
include $(GNUSTEP_MAKEFILES)/Instance/Shared/headers.make
internal-subproject-install_:: shared-instance-headers-install
internal-subproject-uninstall_:: shared-instance-headers-uninstall
endif # no FRAMEWORK
ifeq ($($(GNUSTEP_INSTANCE)_HAS_RESOURCE_BUNDLE), yes)
GNUSTEP_SHARED_BUNDLE_RESOURCE_PATH = $(GNUSTEP_BUILD_DIR)/Resources/Subproject
include $(GNUSTEP_MAKEFILES)/Instance/Shared/bundle.make
internal-subproject-all_:: shared-instance-bundle-all
endif
include $(GNUSTEP_MAKEFILES)/Instance/Shared/strings.make
