ifeq ($(CC), )
  CC=cc
endif
_DEB_ARCH=$(GNUSTEP_TARGET_CPU) # $(shell (/bin/bash -c "$(CC) -dumpmachine | sed -e 's,\\([^-]*\\).*,\\1,g'"))
_DEB_LOWERCASE_PACKAGE_NAME=$(shell (echo $(PACKAGE_NAME) | sed -e 's/\(.*\)/\L\1/'))
_DEB_VERSION=$(TARBALL_VERSION)
ifeq ($(_DEB_VERSION), )
  _DEB_VERSION=$(PACKAGE_VERSION)
endif
ifeq ($(_DEB_VERSION), )
  _DEB_VERSION=$(VERSION)
endif
_DEB_ORIGTARNAME=$(_DEB_LOWERCASE_PACKAGE_NAME)_$(_DEB_VERSION)
_DEB_FILE=$(_DEB_TARNAME)_$(_DEB_ARCH).deb
_ABS_OBJ_DIR=$(shell (cd "$(GNUSTEP_BUILD_DIR)"; pwd))/obj
ifeq ($(debsign),yes)
  DEBUILD_ARGS = -nc
else
  DEBUILD_ARGS = -us -uc -nc
endif
_DEB_TARBALL = $(shell (test -e $(VERSION_NAME).tar.gz && echo $(VERSION_NAME).tar.gz) || \
                       (test -e ../$(VERSION_NAME).tar.gz && echo ../$(VERSION_NAME).tar.gz))
ifeq ($(_DEB_SHOULD_EXPORT), )
_debenv.phony::
	-rm _debenv
	_DEB_SHOULD_EXPORT=1 make _debenv
debclean::
	-rm _debenv
	-rm -rf $(_ABS_OBJ_DIR)/debian_dist
debfiles:: _debenv.phony
	$(ECHO_NOTHING)(if [ -z "$(_DEB_TARBALL)" ] || [ ! -e "$(_DEB_TARBALL)" ] ; then \
	  echo "No tarball found. Please produce it manually using a target such as dist, svn-dist, " ; \
	  echo "svn-bugfix, svn-snapshot or svn-export." ; \
	  echo "Expecting name $(VERSION_NAME).tar.gz in current or parent directory." ; \
	  exit 1 ; \
	fi)$(END_ECHO)
	$(ECHO_NOTHING)echo "Baking deb control files ("$(GNUSTEP_TARGET_CPU)")..."$(END_ECHO)
	/bin/bash -c ". _debenv && mkdir -p $(_ABS_OBJ_DIR)/debian_files && $(GNUSTEP_MAKEFILES)/bake_debian_files.sh $(_ABS_OBJ_DIR)/debian_files"
	-rm _debenv
	$(ECHO_NOTHING)echo "Preparing directory layout for building deb package..."$(END_ECHO)
	-rm -rf $(_ABS_OBJ_DIR)/debian_dist
	mkdir -p $(_ABS_OBJ_DIR)/debian_dist
	cp $(_DEB_TARBALL) $(_ABS_OBJ_DIR)/debian_dist/$(_DEB_ORIGTARNAME).orig.tar.gz
	cd $(_ABS_OBJ_DIR)/debian_dist && tar xfz $(_DEB_ORIGTARNAME).orig.tar.gz
	mkdir -p $(_ABS_OBJ_DIR)/debian_dist/$(VERSION_NAME)/debian
	mv $(_ABS_OBJ_DIR)/debian_files/debian/* $(_ABS_OBJ_DIR)/debian_dist/$(VERSION_NAME)/debian
	-rm -rf $(_ABS_OBJ_DIR)/debian_files
deb::
	$(ECHO_NOTHING)echo "Building Debian package..."$(END_ECHO)
	cd $(_ABS_OBJ_DIR)/debian_dist/$(VERSION_NAME)/ && debuild $(DEBUILD_ARGS) -S
	cd $(_ABS_OBJ_DIR)/debian_dist/$(VERSION_NAME)/ && debuild $(DEBUILD_ARGS) -b
else
ifeq ($(DEB_BUILD_DEPENDS),)
  DEB_BUILD_DEPENDS =gnustep-make (>= $(shell dpkg -s gnustep-make | grep 'Version: ' | sed 's/Version: //'))
  export DEB_BUILD_DEPENDS
else
  DEB_BUILD_DEPENDS +=, gnustep-make (>=  $(shell dpkg -s gnustep-make | grep 'Version: ' | sed 's/Version: //'))
  export DEB_BUILD_DEPENDS
endif
.PHONY: _debenv
export
_debenv:
	export > _debenv
endif
