ifeq ($(RULES_MAKE_LOADED),)
  include $(GNUSTEP_MAKEFILES)/rules.make
endif
PARALLEL_SUBDIRECTORIES := $(strip $(PARALLEL_SUBDIRECTORIES))
ifneq ($(PARALLEL_SUBDIRECTORIES),)
  internal-all internal-clean internal-distclean \
  internal-check internal-strings::
	$(ECHO_NOTHING_RECURSIVE_MAKE)operation=$(subst internal-,,$@); \
	  $(MAKE) -f $(MAKEFILE_NAME) --no-print-directory --no-keep-going \
	  internal-master-subdirectories-$$operation \
	  GNUSTEP_BUILD_DIR="$(GNUSTEP_BUILD_DIR)" \
	  _GNUSTEP_MAKE_PARALLEL=yes$(END_ECHO_RECURSIVE_MAKE)
  .PHONY: \
    internal-master-subdirectories-all \
    internal-master-subdirectories-clean \
    internal-master-subdirectories-distclean \
    internal-master-subdirectories-check \
    internal-master-subdirectories-strings
  internal-master-subdirectories-all: $(PARALLEL_SUBDIRECTORIES:=.all.subdirectories)
  internal-master-subdirectories-clean: $(PARALLEL_SUBDIRECTORIES:=.clean.subdirectories)
  internal-master-subdirectories-distclean: $(PARALLEL_SUBDIRECTORIES:=.distclean.subdirectories)
  internal-master-subdirectories-check: $(PARALLEL_SUBDIRECTORIES:=.check.subdirectories)
  internal-master-subdirectories-strings: $(PARALLEL_SUBDIRECTORIES:=.strings.subdirectories)
  .PRECIOUS: %.subdirectories
  %.subdirectories:
	$(ECHO_NOTHING_RECURSIVE_MAKE)directory=$(basename $*); \
          operation=$(subst .,,$(suffix $*)); \
	  abs_build_dir="$(ABS_GNUSTEP_BUILD_DIR)"; \
	  $(INSIDE_ECHO_MAKING_OPERATION_IN_DIRECTORY) \
	  if [ "$${abs_build_dir}" = "." ]; then \
	    gsbuild="."; \
	  else \
	    gsbuild="$${abs_build_dir}/$$instance"; \
	  fi; \
	  if $(MAKE) -C $$directory -f $(MAKEFILE_NAME) $(GNUSTEP_MAKE_NO_PRINT_DIRECTORY_FLAG) --no-keep-going \
	       $$operation \
	       GNUSTEP_BUILD_DIR="$$gsbuild" _GNUSTEP_MAKE_PARALLEL=no; then \
	    :; else exit $$?; \
	  fi$(END_ECHO_RECURSIVE_MAKE)
  internal-install internal-uninstall::
	$(ECHO_NOTHING_RECURSIVE_MAKE)operation=$(subst internal-,,$@); \
	  abs_build_dir="$(ABS_GNUSTEP_BUILD_DIR)"; \
	for directory in $(PARALLEL_SUBDIRECTORIES); do \
	  $(INSIDE_ECHO_MAKING_OPERATION_IN_DIRECTORY) \
	  if [ "$${abs_build_dir}" = "." ]; then \
	    gsbuild="."; \
	  else \
	    gsbuild="$${abs_build_dir}/$$directory"; \
	  fi; \
	  if $(MAKE) -C $$directory -f $(MAKEFILE_NAME) $(GNUSTEP_MAKE_NO_PRINT_DIRECTORY_FLAG) --no-keep-going \
                     $$operation \
	             GNUSTEP_BUILD_DIR="$$gsbuild" _GNUSTEP_MAKE_PARALLEL=no; then \
	    :; else exit $$?; \
	  fi; \
	done$(END_ECHO_RECURSIVE_MAKE)
endif