ifeq ($(GNUSTEP_BUILD_DIR),.)
all:: before-all internal-all after-all
else
all:: $(GNUSTEP_BUILD_DIR) before-all internal-all after-all
$(GNUSTEP_BUILD_DIR):
	$(ECHO_CREATING)$(MKDIRS) $(GNUSTEP_BUILD_DIR)$(END_ECHO)
endif
jar:: all before-jar internal-jar after-jar
$(GNUSTEP_OBJ_DIR):
	$(ECHO_NOTHING)cd $(GNUSTEP_BUILD_DIR); \
	$(MKDIRS) ./$(GNUSTEP_OBJ_DIR_NAME)$(END_ECHO)
ifeq ($(_GNUSTEP_TOP_INVOCATION_DONE),)
install:: all \
          before-install internal-install after-install internal-after-install
distclean:: clean before-distclean internal-distclean after-distclean
export _GNUSTEP_TOP_INVOCATION_DONE = 1
else
install:: internal-before-install before-install internal-install after-install internal-after-install
distclean:: before-distclean internal-distclean after-distclean
endif
uninstall:: before-uninstall internal-uninstall after-uninstall internal-after-uninstall
clean:: before-clean internal-clean after-clean
check:: before-check internal-check after-check
strings:: before-strings internal-strings after-strings
before-all::
internal-all::
after-all::
before-jar::
internal-jar::
after-jar::
$(ADDITIONAL_INSTALL_DIRS):
	$(ECHO_CREATING)$(MKINSTALLDIRS) $@$(END_ECHO)
internal-before-install:: $(ADDITIONAL_INSTALL_DIRS)
before-install::
internal-install::
after-install::
internal-after-install::
before-uninstall::
internal-uninstall::
after-uninstall::
internal-after-uninstall::
ifneq ($(ADDITIONAL_INSTALL_DIRS),)
	-$(ECHO_NOTHING)for dir in $(ADDITIONAL_INSTALL_DIRS); do \
	  rmdir $$dir ; \
	done$(END_ECHO)
endif
before-clean::
internal-clean::
	rm -rf $(GNUSTEP_BUILD_DIR)/*~ $(GNUSTEP_BUILD_DIR)/obj
after-clean::
before-distclean::
internal-distclean::
after-distclean::
before-check::
internal-check::
after-check::
before-strings::
internal-strings::
after-strings::
.PHONY: \
 all before-all internal-all after-all \
 jar before-jar internal-jar after-jar \
 install before-install internal-install after-install \
 internal-after-install \
 uninstall before-uninstall internal-uninstall after-uninstall \
 clean before-clean internal-clean after-clean \
 distclean before-distclean internal-distclean after-distclean \
 check before-check internal-check after-check \
 strings before-strings internal-strings after-strings \
 build-headers before-build-headers after-build-headers
.PRECIOUS: %.variables %.subprojects
ifeq ($(MAKELEVEL),0)
  ifneq ($(GNUSTEP_BUILD_DIR),.)
    ABS_GNUSTEP_BUILD_DIR = $(shell (cd "$(GNUSTEP_BUILD_DIR)"; pwd))
  else
    ABS_GNUSTEP_BUILD_DIR = .
  endif
else
  ABS_GNUSTEP_BUILD_DIR = $(strip $(GNUSTEP_BUILD_DIR))
endif
%.variables:
	$(ECHO_NOTHING_RECURSIVE_MAKE) \
instance=$(basename $(basename $*)); \
operation=$(subst .,,$(suffix $(basename $*))); \
type=$(subst -,_,$(subst .,,$(suffix $*))); \
abs_build_dir="$(ABS_GNUSTEP_BUILD_DIR)"; \
if [ "$($(basename $(basename $*))_SUBPROJECTS)" != "" ]; then \
  $(INSIDE_ECHO_MAKING_OPERATION_IN_SUBPROJECTS) \
  for f in $($(basename $(basename $*))_SUBPROJECTS) __done; do \
    if [ $$f != __done ]; then       \
      if [ "$${abs_build_dir}" = "." ]; then \
        gsbuild="."; \
      else \
        gsbuild="$${abs_build_dir}/$$f"; \
      fi; \
      if [ "$(OWNING_PROJECT_HEADER_DIR_NAME)" = "" ]; then \
        if [ "$$type" = "framework" ]; then \
          if [ "$(FRAMEWORK_VERSION_SUPPORT)" = "yes" ]; then \
            framework_version="$($(basename $(basename $*))_CURRENT_VERSION_NAME)"; \
            if [ "$$framework_version" = "" ]; then \
              framework_version="$($(basename $(basename $*))_INTERFACE_VERSION)"; \
              if [ "$$framework_version" = "" ]; then \
                framework_version="$(word 1,$(subst ., ,$($(basename $(basename $*))_VERSION)))"; \
                if [ "$$framework_version" = "" ]; then \
                  framework_version="0"; \
                fi; \
              fi; \
            fi; \
            owning_project_header_dir="../$${instance}.framework/Versions/$${framework_version}/Headers"; \
          else \
            owning_project_header_dir="../$${instance}.framework/Headers"; \
          fi; \
       else owning_project_header_dir=""; \
       fi; \
      else \
        owning_project_header_dir="../$(OWNING_PROJECT_HEADER_DIR_NAME)"; \
      fi; \
      if $(MAKE) -C $$f -f $(MAKEFILE_NAME) $(GNUSTEP_MAKE_NO_PRINT_DIRECTORY_FLAG) --no-keep-going $$operation \
          OWNING_PROJECT_HEADER_DIR_NAME="$${owning_project_header_dir}" \
          DERIVED_SOURCES="../$(DERIVED_SOURCES)" \
          GNUSTEP_BUILD_DIR="$$gsbuild" \
	  _GNUSTEP_MAKE_PARALLEL=no \
        ; then \
        :; \
      else exit $$?; \
      fi; \
    fi; \
  done; \
fi; \
$(INSIDE_ECHO_MAKING_OPERATION) \
$(MAKE) -f $(MAKEFILE_NAME) --no-print-directory --no-keep-going \
    internal-$${type}-$$operation \
    GNUSTEP_TYPE=$$type \
    GNUSTEP_INSTANCE=$$instance \
    GNUSTEP_OPERATION=$$operation \
    GNUSTEP_BUILD_DIR="$${abs_build_dir}" \
    _GNUSTEP_MAKE_PARALLEL=no$(END_ECHO_RECURSIVE_MAKE)
%.subprojects:
	$(ECHO_NOTHING_RECURSIVE_MAKE) \
instance=$(basename $(basename $*)); \
operation=$(subst .,,$(suffix $(basename $*))); \
type=$(subst -,_,$(subst .,,$(suffix $*))); \
abs_build_dir="$(ABS_GNUSTEP_BUILD_DIR)"; \
if [ "$($(basename $(basename $*))_SUBPROJECTS)" != "" ]; then \
  $(INSIDE_ECHO_MAKING_OPERATION_IN_SUBPROJECTS) \
  for f in $($(basename $(basename $*))_SUBPROJECTS) __done; do \
    if [ $$f != __done ]; then       \
      if [ "$${abs_build_dir}" = "." ]; then \
        gsbuild="."; \
      else \
        gsbuild="$${abs_build_dir}/$$f"; \
      fi; \
      if [ "$(OWNING_PROJECT_HEADER_DIR_NAME)" = "" ]; then \
        if [ "$$type" = "framework" ]; then \
          if [ "$(FRAMEWORK_VERSION_SUPPORT)" = "yes" ]; then \
            framework_version="$($(basename $(basename $*))_CURRENT_VERSION_NAME)"; \
            if [ "$$framework_version" = "" ]; then \
              framework_version="$($(basename $(basename $*))_INTERFACE_VERSION)"; \
              if [ "$$framework_version" = "" ]; then \
                framework_version="$(word 1,$(subst ., ,$($(basename $(basename $*))_VERSION)))"; \
                if [ "$$framework_version" = "" ]; then \
                  framework_version="0"; \
                fi; \
              fi; \
            fi; \
            owning_project_header_dir="../$${instance}.framework/Versions/$${framework_version}/Headers"; \
          else \
            owning_project_header_dir="../$${instance}.framework/Headers"; \
          fi; \
       else owning_project_header_dir=""; \
       fi; \
      else \
        owning_project_header_dir="../$(OWNING_PROJECT_HEADER_DIR_NAME)"; \
      fi; \
      if $(MAKE) -C $$f -f $(MAKEFILE_NAME) $(GNUSTEP_MAKE_NO_PRINT_DIRECTORY_FLAG) --no-keep-going $$operation \
          OWNING_PROJECT_HEADER_DIR_NAME="$${owning_project_header_dir}" \
          DERIVED_SOURCES="../$(DERIVED_SOURCES)" \
          GNUSTEP_BUILD_DIR="$$gsbuild" \
	  _GNUSTEP_MAKE_PARALLEL=no \
        ; then \
        :; \
      else exit $$?; \
      fi; \
    fi; \
  done; \
fi$(END_ECHO_RECURSIVE_MAKE)
PACKAGE_NAME := $(strip $(PACKAGE_NAME))
ifeq ($(PACKAGE_NAME),)
  PACKAGE_NAME = unnamed-package
endif
ifeq ($(PACKAGE_VERSION),)
  PACKAGE_VERSION = $(VERSION)
  ifeq ($(PACKAGE_VERSION),)
    PACKAGE_VERSION = 0.0.1
  endif
endif
include $(GNUSTEP_MAKEFILES)/Master/source-distribution.make
include $(GNUSTEP_MAKEFILES)/Master/rpm.make
