CYGWIN="no"
if [ ! $# -eq 2 ]; then
  quit="yes"
fi
test "$1" = '-u' || test "$1" = '-w' || quit="yes"
if [ "$quit" = "yes" ]; then
  echo "Usage: $0 (-u)|(-w) filename"
  echo "Options:"
  echo "   -u print Unix form of filename"
  echo "   -w print Windows form of filename"
  exit 1
fi
operation=$1
file=$2
if [ "$operation" = "-u" ]; then
  if [ "$CYGWIN" = "yes" ]; then
    echo $file | \
    tr '\\' '/' | \
    sed 's/^\([a-zA-Z]\):\(.*\)$/\/cygdrive\/\1\2/'
  else
    echo $file | \
    tr '\\' '/' | \
    sed 's/^\([a-zA-Z]\):\(.*\)$/\/\1\2/' | \
    sed 's/\/\//\//'
  fi
else
  if [ "$CYGWIN" = "yes" ]; then
    echo $file | \
    sed 's/^\(\/cygdrive\)\?\/\([a-zA-Z]\)\(\/.*\)$/\2:\3/' | \
    tr '/' '\\'
  else
    echo $file | \
    sed 's/^\/\([a-zA-Z]\)\(\/.*\)$/\1:\2/' | \
    tr '/' '\\'
  fi
fi
exit 0
