mode=strict
if [ "$#" != 2 ]; then
  if [ "$#" != 3 ]; then
    exit 1
  else
    mode="$3"
  fi
fi
a="$1";
b="$2";
if [ "$a" = "" ]; then
  exit 1
fi
if [ "$b" = "" ]; then
  exit 1
fi
tmp_IFS="$IFS"
IFS=/
normalized_a=""
for component in $a; do
  if [ -n "$component" ]; then
    if [ "$component" != "." ]; then
      normalized_a="$normalized_a/$component"
    fi
  fi
done
a="$normalized_a"
normalized_b=""
for component in $b; do
  if [ -n "$component" ]; then
    if [ "$component" != "." ]; then
      normalized_b="$normalized_b/$component"
    fi
  fi
done
b="$normalized_b"
IFS="$tmp_IFS"
tmp_IFS="$IFS"
IFS=/
partial_b=""
partial_match=""
for component in $b; do
  if [ -n "$component" ]; then
    partial_b="$partial_b/$component"
    case "$a" in
      "$partial_b"*) partial_match="$partial_b";;
      *) break;;
    esac
  fi
done
IFS="$tmp_IFS"
if [ "$partial_match" != "" ]; then
  a=`echo $a | sed -e "s#$partial_match##"`
  b=`echo $b | sed -e "s#$partial_match##"`
fi
result="."
tmp_IFS="$IFS"
IFS=/
for component in $a; do
  if [ -n "$component" -a "$component" != "." ]; then
    if [ "$mode" = "strict" ]; then
      result="$result/.."
    else
      if [ "$result" = "." ]; then
        result=".."
      else
        result="$result/.."
      fi
    fi
  fi
done
IFS="$tmp_IFS"
if [ -n "$result" ]; then
  result="$result$b"
else
  result="$b"
fi
if [ "$mode" = "strict" ]; then
  if [ "$result" = "." ]; then
    result="./"
  fi
fi
echo "$result"
